unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    btnConnect: TButton;
    btnRetrieveLayers: TButton;
    btnRetrieveTextStyles: TButton;
    Label1: TLabel;
    Label2: TLabel;
    cbLayers: TComboBox;
    cbTextStyles: TComboBox;
    btnRetrieveDimStyles: TButton;
    Label4: TLabel;
    cbDimStyles: TComboBox;
    btnRetrieveLinetypes: TButton;
    Label5: TLabel;
    cbLinetypes: TComboBox;
    GroupBox1: TGroupBox;
    edLayerName: TEdit;
    btnLayerExist: TButton;
    GroupBox2: TGroupBox;
    edLinetypeName: TEdit;
    btnLinetypeExist: TButton;
    btnSetLayer: TButton;
    btnSetTextStyle: TButton;
    GroupBox3: TGroupBox;
    btnOpen: TButton;
    btnAdd: TButton;
    btnEnumDocs: TButton;
    cbDocs: TComboBox;
    btnCreateLayer: TButton;
    btnLoadLinetype: TButton;
    Label3: TLabel;
    procedure btnConnectClick(Sender: TObject);
    procedure btnRetrieveLayersClick(Sender: TObject);
    procedure btnRetrieveTextStylesClick(Sender: TObject);
    procedure cbLayersDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure btnRetrieveDimStylesClick(Sender: TObject);
    procedure btnRetrieveLinetypesClick(Sender: TObject);
    procedure btnLayerExistClick(Sender: TObject);
    procedure btnLinetypeExistClick(Sender: TObject);
    procedure btnOpenClick(Sender: TObject);
    procedure btnAddClick(Sender: TObject);
    procedure btnEnumDocsClick(Sender: TObject);
    procedure btnSetLayerClick(Sender: TObject);
    procedure btnCreateLayerClick(Sender: TObject);
    procedure btnLoadLinetypeClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses UAutoCAD;

{$R *.dfm}

procedure TForm1.btnConnectClick(Sender: TObject);
begin
  AcConnect(rsDefClassName, False, True);
end;

procedure TForm1.btnRetrieveLayersClick(Sender: TObject);
begin
  cbLayers.ItemIndex:= EnumAutoCADLayers(cbLayers.Items);
end;

procedure TForm1.btnRetrieveTextStylesClick(Sender: TObject);
begin
  cbTextStyles.ItemIndex:= EnumAutoCADTextStyles(cbTextStyles.Items);
end;

procedure TForm1.cbLayersDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
var
  Tmp: Integer;
  States: TLayerStates;
begin
  with Control as TComboBox do
  begin
    Tmp:= Integer(Items.Objects[Index]);
    Move(Tmp, States, 1);
    with cbLayers.Canvas do
    begin
      FillRect(Rect);
      if not (lsLayerOn in States) or (lsFreeze in States) or
         (lsLock in States) or not (lsPlottable in States) then Font.Color:= clGrayText;
      if Index >= 0 then
        TextOut(Rect.Left + 2, Rect.Top + 1, cbLayers.Items[Index]);
    end;
  end;
end;

procedure TForm1.btnRetrieveDimStylesClick(Sender: TObject);
begin
  cbDimStyles.ItemIndex:= EnumAutoCADDimStyles(cbDimStyles.Items);
end;

procedure TForm1.btnRetrieveLinetypesClick(Sender: TObject);
begin
  cbLinetypes.ItemIndex:= EnumAutoCADLinetypes(cbLinetypes.Items);
end;

procedure TForm1.btnLayerExistClick(Sender: TObject);
begin
  if LayerExist(edLayerName.Text) then
    ShowMessage(Format(' %s !', [edLayerName.Text]))
  else
    ShowMessage(Format(' %s  !', [edLayerName.Text]));
end;

procedure TForm1.btnLinetypeExistClick(Sender: TObject);
begin
  if LinetypeExist(edLinetypeName.Text) then
    ShowMessage(Format('  %s !', [edLinetypeName.Text]))
  else
    ShowMessage(Format('  %s  !', [edLinetypeName.Text]));
end;

procedure TForm1.btnOpenClick(Sender: TObject);
var
  Doc: OleVariant;
begin
  Doc:= Acad.Documents.Open(ExtractFilePath(Application.ExeName) + 'clouds.dwg');
  ShowMessage(Format('  "%s"', [Doc.Name]));
end;

procedure TForm1.btnAddClick(Sender: TObject);
var
  Doc: OleVariant;
begin
  Doc:= Acad.Documents.Add('');
  ShowMessage(Format('   "%s"', [Doc.Name]));
end;

procedure TForm1.btnEnumDocsClick(Sender: TObject);
begin
  cbDocs.ItemIndex:= EnumAutoCADDocuments(cbDocs.Items);
end;

procedure TForm1.btnSetLayerClick(Sender: TObject);
begin
  if cbLayers.ItemIndex > -1 then
    SetActiveLayer(cbLayers.Items[cbLayers.ItemIndex]);
end;

procedure TForm1.btnCreateLayerClick(Sender: TObject);
begin
  Acad.ActiveDocument.Layers.Add('NewLayer');
end;

procedure TForm1.btnLoadLinetypeClick(Sender: TObject);
begin
  Acad.ActiveDocument.Linetypes.Load('DASHED', 'acad.lin');
end;

end.
